#!/usr/bin/python
# -*- coding:utf-8 -*-

import os, string, re, sys
from dom import *

def convert_radio_html_to_csv( filename_input, ostream = sys.stdout ):
    fn = filename_input
    file_radio = open( fn )
    line = file_radio.readline()

    re_channel = re.compile( "<a target='tv' href='(.*?)'>(.*?)</a>" )
    re_spacer  = re.compile( "<td.*?>\\s*&nbsp;\\s*</td>" )
    re_tagremover = re.compile( "<[a-zA-Z/][^>]+>" )
    keyword_midnight = "<small>0</small>"
    flag_midnight = False

    channels = []

    # read title
    re_title = re.compile( "<title>(.*?)</title>" )
    while line != "":
        m = re_title.search( line )
        if m:
            title = m.group( 1 )
            area = title
            m = re.search( "\[(.*?)/(.*?)/[^\]]+\]", title )
            if m:
                area = m.group( 2 )
                wave = m.group( 1 )
                pass
            m = re.search( "(\\d+)月(\\d+)日", title )
            if m:
                date = m.group( 1 ) + "/" + m.group( 2 )
                pass
            break
        line = file_radio.readline()
        pass
    ostream.write( "#%s,%s,%s\n" % ( area, date, wave ) )

    # skip until channels
    while line != "":
        if line.strip() == "<!--- navi-->":break
        line = file_radio.readline()
        pass

    while line != "":
        line = line.strip()
        if line == "</tr>":break
        m = re_channel.search( line )
        if m:
            link = m.group( 1 )
            name = re_tagremover.sub( "", m.group( 2 ) )
            channels.append( {"name":name, "link":link, "length":0, "progs":[] } )
        else:
            m = re_spacer.search( line )
            if m:
                channels.append( {"name":None, "link":None, "length":0, "progs":[] } )
                pass
            pass
        line = file_radio.readline()
        pass


    parser = DOMConverter()
    parser.feed( "<html>" )
    while line != "":
        if line.strip() == "<!--- link-->": break
        if line.find( '<img alt=' ) >= 0:
            m = re.search( "<img alt='([^']*)'.*?src='[^']+/(\\w+).gif'>", line )
            if m:
                alt = m.group( 1 )
                src = m.group( 2 )
                if src == "news":
                    item = '[N]'
                elif src == "weather":
                    item = "[天]"
                elif src == "saihousou":
                    item = "[再]"
                    pass
                else:
                    item = '[' + alt + ']'
                    pass
                line = line[ 0: m.start() ] + item + line[ m.end() : ]
                pass
        parser.feed( line )
        line = file_radio.readline()
        pass
    parser.feed( "</html>" )



    doc = parser.get_document()
    row = doc.get_element_at_path( "/html/tr" )
    count = 0
    columns = len( channels )
    start = 0
    while start < columns:
        if channels[ start ] != None:
            break
        start += 1
        pass

    while row:
        datum = row.get_element_at_path( 'td' )
        if datum:
            count_column = 0
            while datum:
                try:
                    if datum.get_attribute( 'class' ) == 'n': break
                except:
                    pass
                if datum.has_attribute( 'rowspan' ):
                    rowspan = string.atoi( datum.get_attribute( 'rowspan' ) )
                    minitem = start
                    minvalue = channels[ start ][ "length" ]
                    for i in range( start + 1, columns ):
                        if channels[ i ] == None: continue
                        length = channels[ i ][ "length" ]
                        if length < minvalue:
                            minitem = i
                            minvalue = length
                            pass
                        pass
                    if channels[ minitem ][ "name" ] != None:
                        channels[ minitem ][ "progs" ].append( "%d" % rowspan + datum.get_text( ',' ) )
                        pass
                    channels[ minitem ][ "length" ] += rowspan

                count_column += 1
                try:
                    datum = datum.next_sibling( 'td' )
                except:
                    break
                pass
            if count_column > 0:
                count += 1
                pass

            pass
        try:
            row = row.next_sibling( 'tr' )
        except:
            break
        pass

    for ch in channels:
        name = ch[ "name" ]
        if name:
            ostream.write( "*%s,%s\n" % ( name, ch[ "link" ] ) )
            flag_midnight = False
            for p in ch[ "progs" ]:
                line = p
                items = re.split( ',', line )
                if len( items ) > 2:
                    time_span = items[ 0 ]
                    time_start = items[ 1 ]
                    hr, mn = re.split( ':', time_start )
                    time_start = string.atoi( hr ) * 60 + string.atoi( mn )
                    if flag_midnight and time_start < 720:
                        time_start += 1440
                        pass
                    elif time_start >= 720:
                        flag_midnight = True
                        pass
                    title = items[ 2 ]
                    for i in range( 3, len( items ) ):
                        title += items[ i ]
                        pass
                    desc = ""
                    #p = title.find( '▽' )
                    m = re.search( '(.*?)(▽|\\s+|　|「|〜)(.*)', title )
                    if m:
                        title = m.group( 1 )
                        if m.group( 2 ) == '　' or m.group( 2 ) == '〜' :
                            desc = m.group( 3 )
                        else:
                            desc  = m.group( 2 ) + m.group( 3 )
                            pass
                        pass
                    genre = 0
                    ostream.write( "%d,%s,%s,%s,,%d\n" % ( time_start, time_span, title, desc, genre ) )
                pass
            ostream.write( "\n" )
            pass
        pass
    file_radio.close()
    pass

if __name__ == "__main__":
    convert_radio_html_to_csv( sys.argv[ 1 ], sys.stdout )
    pass
